.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\macros\macros.asm

include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib

.data

szGetModuleHandle db "GetModuleHandle",0
szExitProcess db "ExitProcess",0
szLoadLibrary db "LoadLibrary",0

szMessageBox db "MessageBox",0
szLoadIcon db "LoadIcon",0
szLoadCursor db "LoadCursor",0
szRegisterClassEx db "RegisterClassEx",0
szCreateWindowEx db "CreateWindowEx",0
szShowWindow db "ShowWindow",0
szUpdateWindow db "UpdateWindow",0
szGetMessage db "GetMessage",0
szTranslateMessage db "TranslateMessage",0
szDispatchMessage db "DispatchMessage",0
szDefWindowProc db "DefWindowProc",0
szPostQuitMessage db "PostQuitMessage",0
szBeginPaint db "BeginPaint",0
szGetClientRect db "GetClientRect",0
szDrawText db "DrawText",0
szEndPaint db "EndPaint",0

_GetModuleHandle dd 0
_ExitProcess dd 0
_LoadLibrary dd 0

_MessageBox dd 0
_LoadIcon dd 0
_LoadCursor dd 0
_RegisterClassEx dd 0
_CreateWindowEx dd 0
_ShowWindow dd 0
_UpdateWindow dd 0
_GetMessage dd 0
_TranslateMessage dd 0
_DispatchMessage dd 0
_DefWindowProc dd 0
_PostQuitMessage dd 0
_BeginPaint dd 0
_GetClientRect dd 0
_DrawText dd 0
_EndPaint dd 0

szUSER32 db "USER32",0

_default dd 0

szClassName db "Bare_WndClass",0
szAppName db "Bare",0
szAppText db "How can you make a window with no imports?"

hInstance dd 0
hwndMain dd 0
wc WNDCLASSEX <?>
msg MSG <?>
ps PAINTSTRUCT <?>
rect RECT <?>

.code

start:
	
	mov ebp,0
	
	mov ecx,[esp]
	KernelLoop:
	xor edx,edx
	sub ecx,1
	mov dx,[ecx+3Ch]
	test dx,0F800h
	jnz KernelLoop
	cmp ecx,[ecx+edx+34h]
	jnz KernelLoop
	mov edi,offset _default
	mov [edi],ecx
	
	mov esi,offset szGetModuleHandle
	mov ecx,15
	call GetApi
	mov edi,offset _GetModuleHandle
	mov [edi],eax
	mov esi,offset szExitProcess
	mov ecx,11
	call GetApi
	mov _ExitProcess,eax
	mov esi,offset szLoadLibrary
	mov ecx,11
	call GetApi
	mov _LoadLibrary,eax
	
	push offset szUSER32
	call eax
	mov _default,eax
	
	mov esi,offset szMessageBox
	mov ecx,10
	call GetApi
	mov _MessageBox,eax
	mov esi,offset szLoadIcon
	mov ecx,8
	call GetApi
	mov _LoadIcon,eax
	mov esi,offset szLoadCursor
	mov ecx,10
	call GetApi
	mov _LoadCursor,eax
	mov esi,offset szRegisterClassEx
	mov ecx,15
	call GetApi
	mov _RegisterClassEx,eax
	mov esi,offset szCreateWindowEx
	mov ecx,14
	call GetApi
	mov _CreateWindowEx,eax
	mov esi,offset szShowWindow
	mov ecx,10
	call GetApi
	mov _ShowWindow,eax
	mov esi,offset szUpdateWindow
	mov ecx,12
	call GetApi
	mov _UpdateWindow,eax
	mov esi,offset szGetMessage
	mov ecx,10
	call GetApi
	mov _GetMessage,eax
	mov esi,offset szTranslateMessage
	mov ecx,16
	call GetApi
	mov _TranslateMessage,eax
	mov esi,offset szDispatchMessage
	mov ecx,15
	call GetApi
	mov _DispatchMessage,eax
	mov esi,offset szDefWindowProc
	mov ecx,13
	call GetApi
	mov _DefWindowProc,eax
	mov esi,offset szPostQuitMessage
	mov ecx,15
	call GetApi
	mov _PostQuitMessage,eax
	mov esi,offset szBeginPaint
	mov ecx,10
	call GetApi
	mov _BeginPaint,eax
	mov esi,offset szGetClientRect
	mov ecx,13
	call GetApi
	mov _GetClientRect,eax
	mov esi,offset szDrawText
	mov ecx,8
	call GetApi
	mov _DrawText,eax
	mov esi,offset szEndPaint
	mov ecx,8
	call GetApi
	mov _EndPaint,eax
	
	push 0
	call _GetModuleHandle
	mov hInstance,eax
	
	mov wc.cbSize,sizeof wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov wc.hInstance,eax
	push IDI_APPLICATION
	push 0
	call _LoadIcon
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	push IDC_ARROW
	push 0
	call _LoadCursor
	mov wc.hCursor,eax
	mov wc.hbrBackground,COLOR_WINDOW+1
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset szClassName
	push offset wc
	call _RegisterClassEx
	
	push 0
	push hInstance
	push 0
	push 0
	push CW_USEDEFAULT
	push CW_USEDEFAULT
	push CW_USEDEFAULT
	push CW_USEDEFAULT
	push WS_OVERLAPPEDWINDOW
	push offset szAppName
	push offset szClassName
	push 0
	call _CreateWindowEx
	push eax
	push SW_SHOWDEFAULT
	push eax
	call _ShowWindow
	call _UpdateWindow
	
	@@:
	push 0
	push 0
	push 0
	push offset msg
	call _GetMessage
	or eax,eax
	jz Exit
	push offset msg
	call _TranslateMessage
	push offset msg
	call _DispatchMessage
	jmp @B
	
	Exit:
	push msg.wParam
	call _ExitProcess
	
	WndProc:
	cmp dword ptr [esp+8],WM_DESTROY
	jnz @F
	push 0
	call _PostQuitMessage
	xor eax,eax
	ret 16
	@@:
	cmp dword ptr [esp+8],WM_PAINT
	jnz @F
	push offset ps
	push dword ptr [esp+8]
	call _BeginPaint
	push eax
	push offset rect
	push dword ptr [esp+12]
	call _GetClientRect
	pop eax
	push DT_SINGLELINE or DT_CENTER or DT_VCENTER
	push offset rect
	push -1
	push offset szAppText
	push eax
	call _DrawText
	push offset ps
	push dword ptr [esp+8]
	call _EndPaint
	xor eax,eax
	ret 16
	@@:
	push dword ptr [esp+16]
	push dword ptr [esp+16]
	push dword ptr [esp+16]
	push dword ptr [esp+16]
	call _DefWindowProc
	ret 16
	
	GetApi:
	mov edx,_default
	add edx,[edx+3Ch]
	mov edx,[edx+78h]
	add edx,_default
	mov edi,[edx+32]
	add edi,_default
	mov edi,[edi]
	add edi,_default
	mov eax,[edx+24]
	xor ebx,ebx
	NextOne:
	push ecx
	add ebx,1
	push esi
	push edi
	repz cmpsb
	pop edi
	pop esi
	jnz NotFound
	pop ecx
	mov ecx,[edx+36]
	add ecx,_default
	sub ebx,1
	movzx eax,word ptr [ecx+ebx*2]
	mov ebx,[edx+28]
	add ebx,_default
	mov eax,[ebx+eax*4]
	add eax,_default
	ret
	NotFound:
	sub edi,1
	@@:
	add edi,1
	cmp byte ptr [edi],0
	jnz @B
	add edi,1
	sub eax,1
	jz BreakSearch
	pop ecx
	jmp NextOne
	BreakSearch:
	push 0
	call _ExitProcess
	ret

end start